    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------
    028     * DateTick.java
    029     * -------------
    030     * (C) Copyright 2003-2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 07-Nov-2003 : Version 1 (DG);
    038     * 13-May-2004 : Added equals() method (DG);
    039     *
    040     */
    041
    042    package org.jfree.chart.axis;
    043
    044    import java.util.Date;
    045
    046    import org.jfree.ui.TextAnchor;
    047    import org.jfree.util.ObjectUtilities;
    048
    049    /**
    050     * A tick used by the {@link DateAxis} class.
    051     */
    052    public class DateTick extends ValueTick {
    053
    054        /** The date. */
    055        private Date date;
    056
    057        /**
    058         * Creates a new date tick.
    059         *
    060         * @param date  the date.
    061         * @param label  the label.
    062         * @param textAnchor  the part of the label that is aligned to the anchor
    063         *                    point.
    064         * @param rotationAnchor  defines the rotation point relative to the text.
    065         * @param angle  the rotation angle (in radians).
    066         */
    067        public DateTick(Date date, String label,
    068                        TextAnchor textAnchor, TextAnchor rotationAnchor,
    069                        double angle) {
    070
    071            super(date.getTime(), label, textAnchor, rotationAnchor, angle);
    072            this.date = date;
    073
    074        }
    075
    076        /**
    077         * Returns the date.
    078         *
    079         * @return The date.
    080         */
    081        public Date getDate() {
    082            return this.date;
    083        }
    084
    085        /**
    086         * Tests this tick for equality with an arbitrary object.
    087         *
    088         * @param obj  the object to test (<code>null</code> permitted).
    089         *
    090         * @return A boolean.
    091         */
    092        public boolean equals(Object obj) {
    093            if (obj == this) {
    094                return true;
    095            }
    096            if (obj instanceof DateTick && super.equals(obj)) {
    097                DateTick dt = (DateTick) obj;
    098                if (!ObjectUtilities.equal(this.date, dt.date)) {
    099                    return false;
    100                }
    101                return true;
    102            }
    103            return false;
    104        }
    105
    106        /**
    107         * Returns a hash code for this object.
    108         *
    109         * @return A hash code.
    110         */
    111        public int hashCode() {
    112            return this.date.hashCode();
    113        }
    114
    115    }